{    var   : }
{ K, K2, F, M, IU, THRESH, MEXACT }
Unit de75e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE75EK_p, DE70EH_p, DE75E1_p, DE71EE_p, DE71EF_p, DE70EI_p,
DE70EF_p, DE70EC_p, DE70EQ_p, DE75EE_p, DE75EN_p, DE75E0_p, UTDE75_p;

procedure DE75E(F :Proc_F70E; var M :Integer; var K :Integer;
                INIAPR :Integer; IMAX :Integer; var JSTART :Integer;
                var YX :Array of Extended; var X :Extended;
                var IU :Integer; EPS :Extended; var THRESH :Extended;
                var H :Extended; HMIN :Extended; var BUL :Boolean;
                var XP :Extended; var YP :Array of Extended;
                var MEXACT :Integer; var NUMBES :Array of Integer;
                var DELTY :Array of Extended; var RO :Array of Extended;
                MESTER :Integer; var K2 :Integer; IMAX2 :Integer;
                var YX2 :Array of Extended; NATTEM :Integer;
                var AU :Array of Extended; var AJK :Array of Extended;
                var AU2 :Array of Extended; var AJK2 :Array of Extended;
                var XJ0 :Array of Extended; var XJ02 :Array of Extended;
                var AJKP :Array of Extended; var U :Array of Extended;
                var U2 :Array of Extended; var ZFI :Array of Extended;
                var ZFI2 :Array of Extended; var HD4I :Array of Extended;
                var RABC :Array of Extended; var ALP :Array of Extended;
                var ALPN :Array of Extended; var CMAR :Array of Extended;
                var P :Array of Extended; var S :Array of Extended;
                var ALP2 :Array of Extended; var ALPN2 :Array of Extended;
                var CMAR2 :Array of Extended; var IERR :Integer);

implementation

procedure DE75E(F :Proc_F70E; var M :Integer; var K :Integer;
                INIAPR :Integer; IMAX :Integer; var JSTART :Integer;
                var YX :Array of Extended; var X :Extended;
                var IU :Integer; EPS :Extended; var THRESH :Extended;
                var H :Extended; HMIN :Extended; var BUL :Boolean;
                var XP :Extended; var YP :Array of Extended;
                var MEXACT :Integer; var NUMBES :Array of Integer;
                var DELTY :Array of Extended; var RO :Array of Extended;
                MESTER :Integer; var K2 :Integer; IMAX2 :Integer;
                var YX2 :Array of Extended; NATTEM :Integer;
                var AU :Array of Extended; var AJK :Array of Extended;
                var AU2 :Array of Extended; var AJK2 :Array of Extended;
                var XJ0 :Array of Extended; var XJ02 :Array of Extended;
                var AJKP :Array of Extended; var U :Array of Extended;
                var U2 :Array of Extended; var ZFI :Array of Extended;
                var ZFI2 :Array of Extended; var HD4I :Array of Extended;
                var RABC :Array of Extended; var ALP :Array of Extended;
                var ALPN :Array of Extended; var CMAR :Array of Extended;
                var P :Array of Extended; var S :Array of Extended;
                var ALP2 :Array of Extended; var ALPN2 :Array of Extended;
                var CMAR2 :Array of Extended; var IERR :Integer);
var
ICOUNT,KP1,KP2,K2P1,K2P2,L,J,IEXIT,NU :Integer;
C :Real;
KSI,ROMAX,W,DZETA :Extended;
BULH,BULQ :Boolean;
label
_45,_50,_55,_60,_65,_70,_80,_85,_90,_95,_100,_110,_120,_125,_130,_140,
_145,_150,_155,_160,_165,_170,_175,_180,_185,_190,_195,_200,_205,_210,
_215,_225,_230,_235,_240,_245,_250,_270,_285,_290,_295,_310,_345,_370,
_380;
begin
{  }
{  }
{  }
{  }
{  }
{  }
{  }
{  }
IERR := 0;
BULH := False;
BULQ := False;
ICOUNT := 0;
KP1 := K+1;
KP2 := K+2;
K2P1 := K2+1;
K2P2 := K2+2;
XP := X;
for L:=1 to M do
 begin
_45:
  YP[L-1] := YX[L-1];
 end;
if ( JSTART <> 0 ) 
 then goto _55;
{  }
{        THE FIRST STEP REALIZATION }
{        CALCULATION OF ALL VARIABLES DEPENDING ON K }
{  }
DE75EK(K,RABC,ALP,ALPN,CMAR,P,S,K2,ALP2,ALPN2,CMAR2);
{  }
{        CALCULATION OF ALL VARIABLES DEPENDING ON H }
{        AND ALSO VARIABLES DEPENDING ON H AND K }
{  }
DE70EH(K2,H,HD4I);
for J:=1 to K do
 begin
_50:
  XJ0[J-1] := XP+ALP[J-1]*H;
 end;
DE75E1(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI);
goto _110;
{  }
{        THE NEXT STEP REALIZATION }
{  };
_55:
for J:=1 to K do
 begin
_60:
  XJ0[J-1] := XP+ALP[J-1]*H;
 end;
{        CHEBYSHEV COEFFICIENTS FROM PREVIOUS STEP ARE STORED }
for J:=1 to KP1 do
 begin
  for L:=1 to M do
   begin
_65:
    AJKP[(L-1)+(J-1)*M] := AJK[(L-1)+(J-1)*M];
   end;
_70:
 end;
{  }
if ( H = _COM70D.elm7 ) 
 then goto _80;
{        RECALCULATION OF ALL VARIABLS DEPENDING ON H }
DE70EH(K2,H,HD4I);
{  };
_80:
if ( INIAPR <> 1 ) 
 then goto _85;
{        CALCULATE INITIAL APPROXIMATION FROM INITIAL CONDITION ALWAYS }
DE75E1(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI);
goto _110;
{        CALCULATE INITIAL APPROXIMATION BY EXTRAPOLATION OF COEFFICIENTS }
{        AJK FROM PREVIOUS STEP };
_85:
if ( H = _COM70D.elm7 ) 
 then goto _90;
KSI := H/_COM70D.elm7;
DE71EE(M,K,P,AJK,KSI,ZFI[(KP2-1)*M]);
goto _95;
_90:
DE71EF(M,K,S,AJK,ZFI[(KP2-1)*M]);
{  };
_95:
if ( BULQ ) 
 then goto _110;
F(XP,YP,ZFI[(K+3)*M],M);
for L:=1 to M do
 begin
_100:
  ZFI[(L-1)+0*M] := ZFI[(L-1)+(K+3)*M]*_COM70D.elm2;
 end;
{  };
_110:
IEXIT := 0;
for NU:=1 to IMAX do
 begin
  DE70EI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI);
_120:
 end;
IEXIT := 3;
DE70EI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI);
DE70EF(M,KP1,AU,YX);
{  }
{ ------  CALCULATION OF THE SECOND SOLUTION OF (K2+1) ORDER   ---------- }
{  }
for J:=1 to K2 do
 begin
  DE70EC(M,KP1,ALPN2[J-1],AU,U2[(J-1)*M],ZFI[(KP2-1)*M]);
_125:
 end;
for J:=1 to K2 do
 begin
  XJ02[J-1] := XP+ALP2[J-1]*H;
  F(XJ02[J-1],U2[(J-1)*M],ZFI2[(J+0)*M],M);
_130:
 end;
{  }
if ( BULQ ) 
 then goto _145;
{  }
{     CALCULATION OF CONSTANT PARTIAL IN MARKOV QUADRATURE FOR K=K2 }
{  }
for L:=1 to M do
 begin
_140:
  ZFI2[(L-1)+0*M] := ZFI[(L-1)+(K+3)*M]*_COM75D.elm5;
 end;
{  };
_145:
_COM70D.elm3 := _COM75D.elm6;
_COM70D.elm4 := _COM75D.elm2;
DE70EQ(M,K2,ZFI2,CMAR2,AJK2);
IEXIT := 0;
for NU:=1 to IMAX2 do
 begin
  DE70EI(F,M,K2,IEXIT,YP,XJ02,AJK2,HD4I,RABC,ALPN2,CMAR2,AU2,
       U2,ZFI2);
_150:
 end;
IEXIT := 3;
DE70EI(F,M,K2,IEXIT,YP,XJ02,AJK2,HD4I,RABC,ALPN2,CMAR2,AU2,
     U2,ZFI2);
DE70EF(M,K2P1,AU2,YX2);
_COM70D.elm3 := _COM75D.elm3;
_COM70D.elm3 := _COM75D.elm3;
_COM70D.elm4 := _COM75D.elm1;
{  }
{ ----------------------------------------------------------------------- }
{  }
case MESTER of
 1: goto _155;
 2: goto _185;
end;
{  }
{ -------- CALCULATION OF ABSOLUTE ERROR -------------------------------- }
{  };
_155:
for L:=1 to M do
 begin
  DELTY[L-1] := YX2[L-1]-YX[L-1];
_160:
  RO[L-1] := DELTY[L-1];
 end;
{  }
{ ----------------------------------------------------------------------- }
case IU of
 1: goto _205;
 2: goto _165;
 3: goto _175;
end;
{  }
{ -------- CALCULATION OF RELATIVE ERROR }
{  };
_165:
for L:=1 to M do
 begin
  if ( YX[L-1] = 0.e0 ) 
   then goto _170;
  RO[L-1] := DELTY[L-1]/Abs(YX[L-1]);
_170:
 end;
goto _205;
{  }
{ -------- CALCULATION OF MEASURE ERROR }
{  };
_175:
for L:=1 to M do
 begin
  if ( Abs(YX[L-1]) < THRESH )
   then goto _180;
  RO[L-1] := DELTY[L-1]/Abs(YX[L-1]);
_180:
 end;
goto _205;
{  }
{ -------- CALCULATION OF ESTIMATE OF ABSOLUTE ERROR -------------------- }
{  };
_185:
for L:=1 to M do
 begin
  W := 0.5e0*(Abs(AU2[(L-1)+0*M]-AU[(L-1)+0*M]));
  for J:=2 to KP2 do
   begin
_190:
    W := W  +   Abs(AU2[(L-1)+(J-1)*M]-AU[(L-1)+(J-1)*M]);
   end;
  for J:=KP2+1 to K2P2 do
   begin
_195:
    W := W+Abs(AU2[(L-1)+(J-1)*M]);
   end;
  DELTY[L-1] := W;
_200:
  RO[L-1] := DELTY[L-1];
 end;
{ ----------------------------------------------------------------------- }
{  }
DE75EE(M,K,IU,THRESH,DELTY,YX,U,RO);
{  }
{ -------- CALCULATION OF NORM ERROR }
{  };
_205:
DE75EN(M,MEXACT,NUMBES,RO,ROMAX);
if ( ROMAX = 0.e0 ) 
 then goto _210;
DZETA := Exp(Ln(EPS/ROMAX)/(KP2));
goto _215;
_210:
DZETA := 10.e0;
_215:
if ( ROMAX <= EPS ) 
 then goto _270;
{ ----------------------------------------------------------------------- }
{  }
{ ------ THE ACCURACY IS NOT ACHIEVED }
{  }
{       STATISTICS }
_STAT76.elm2 := _STAT76.elm2+1;
{  }
if ( BULH ) 
 then goto _310;
H := 0.9e0*H*DZETA;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _225;
H := Sign(HMIN,H);
BULH := True;
{  }
{ ---------  PREPARATION TO REPEAT CALCULATION OF TWO SOLUTIONS YX AND YX }
{                IN NEW ELEMENTARY SEGMENT }
{  };
_225:
if ( ICOUNT = NATTEM ) 
 then goto _345;
ICOUNT := ICOUNT+1;
BULQ := True;
_230:
for J:=1 to K do
 begin
_235:
  XJ0[J-1] := XP+ALP[J-1]*H;
 end;
{  }
{ --------RECALCULATION OF ALL VARIABLES DEPEDING ON H }
{  }
DE70EH(K2,H,HD4I);
{  }
if ( INIAPR <> 1 ) and ( JSTART = 1 ) 
 then goto _240;
DE75E0(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI);
goto _110;
{  };
_240:
for J:=1 to KP1 do
 begin
  for L:=1 to M do
   begin
_245:
    AJK[(L-1)+(J-1)*M] := AJKP[(L-1)+(J-1)*M];
   end;
_250:
 end;
goto _85;
{ ----------------------------------------------------------------------- }
{  }
{ ....................................................................... }
{  }
{ ------ THE ACCURACY IS ACHIEVED }
{  };
_270:
X := XP+H;
_COM70D.elm7 := H;
{  }
{        STATISTICS }
_STAT76.elm1 := _STAT76.elm1+1;
{  }
{ ----------FORMATION OF ANSWERS }
{  }
for J:=1 to KP1 do
 begin
  for L:=1 to M do
   begin
    AJK[(L-1)+(J-1)*M] := AJK2[(L-1)+(J-1)*M];
_285:
    AU[(L-1)+(J-1)*M] := AU2[(L-1)+(J-1)*M];
   end;
_290:
 end;
{  }
for L:=1 to M do
 begin
  YX[L-1] := YX2[L-1];
_295:
  AU[(L-1)+(KP2-1)*M] := AU2[(L-1)+(KP2-1)*M];
 end;
{  }
H := 0.9e0*H*DZETA;
goto _380;
{ ....................................................................... };
_310:
IERR := 65;
goto _370;
_345:
IERR := 66;
_370:
UTDE75(IERR,75);
_380:
JSTART := 1;
end;

end.
